﻿using MyDiskInfo.DataStruct;
using MyDiskInfo.Service;
using OpenHardwareMonitor.Hardware;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MyDiskInfoService.Utils
{
    /// <summary>
    /// 获取CPU信息
    /// </summary>
    public static class CpuInfoUtil
    {
        private static Computer _computer = new Computer();
        private static HardwareVisitor _hardwareVisitor = new HardwareVisitor();
        private static object _lock = new object();
        private static bool _isOpen = false;

        /// <summary>
        /// 获取CPU信息
        /// </summary>
        public static CpuModel GetInfo()
        {
            lock (_lock)
            {
                if (!_isOpen)
                {
                    _isOpen = true;
                    _computer.Open();
                    _computer.CPUEnabled = true;
                }
            }

            CpuModel model = new CpuModel();

            _computer.Accept(_hardwareVisitor);

            foreach (IHardware hardware in _computer.Hardware)
            {
                double load = 0;
                double clock = 0;
                double temperature = 0;

                double loadCount = 0;
                double clockCount = 0;
                double temperatureCount = 0;

                if (hardware.HardwareType == HardwareType.CPU)
                {
                    foreach (ISensor sensor in hardware.Sensors)
                    {
                        if (sensor.SensorType == SensorType.Load)
                        {
                            loadCount++;
                            load += sensor.Value ?? 0;
                        }
                        if (sensor.SensorType == SensorType.Clock)
                        {

                        }
                        if (sensor.SensorType == SensorType.Temperature)
                        {

                        }
                    }
                }

                load = load / loadCount;
                model.Load = load;
            }

            return model;
        }
    }
}
