﻿using DataStruct;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Management;
using System.Text;
using System.Threading.Tasks;

namespace MyDiskInfo.Service
{
    /// <summary>
    /// 硬盘信息工具类
    /// </summary>
    public class DiskInfoUtil
    {
        public static DiskModel GetInfo()
        {
            DiskModel result = new DiskModel();

            try
            {
                //根据硬盘Caption获取硬盘Index
                int diskIndex = 0;
                ManagementClass mc = new ManagementClass("Win32_DiskDrive");
                ManagementObjectCollection moc = mc.GetInstances();
                foreach (ManagementObject mo in moc)
                {
                    string caption = mo.Properties["Caption"].Value.ToString();
                    if (caption == ConfigUtil.SSDCaption)
                    {
                        diskIndex = Convert.ToInt32(mo.Properties["Index"].Value);
                    }
                }

                var searcher = new ManagementObjectSearcher("Select * from Win32_DiskDrive");
                searcher.Scope = new ManagementScope(@"\root\wmi");

                searcher.Query = new ObjectQuery("Select * from MSStorageDriver_FailurePredictData");
                ManagementObject data = searcher.Get().Cast<ManagementObject>().ElementAt(diskIndex);
                byte[] bytes = (byte[])data.Properties["VendorSpecific"].Value;
                for (int i = 0; i * 12 + 7 + 4 < bytes.Length; ++i)
                {
                    int id = bytes[i * 12 + 2];
                    if (id == 0xF1)
                    {
                        //int flags = bytes[i * 12 + 4];
                        //bool failureImminent = (flags & 0x1) == 0x1;
                        //int value = bytes[i * 12 + 5];
                        //int worst = bytes[i * 12 + 6];
                        int vendordata = BitConverter.ToInt32(bytes, i * 12 + 7);
                        result.LBA_Write = vendordata;
                    }
                    if (id == 0xF2)
                    {
                        int vendordata = BitConverter.ToInt32(bytes, i * 12 + 7);
                        result.LBA_Read = vendordata;
                    }
                    if (id == 0xAD)
                    {
                        int vendordata = BitConverter.ToInt32(bytes, i * 12 + 7);
                        result.PE = vendordata;
                    }
                }

                string[] strArr = ConfigUtil.LBATodayWrite.Split('|');
                string strToday = DateTime.Now.ToString("yyyyMMdd");
                if (strToday == strArr[0])
                {
                    int lastNum = Convert.ToInt32(strArr[1]);
                    result.LBA_TodayWrite = result.LBA_Write - lastNum;
                }
                else
                {
                    int lastNum = result.LBA_Write;
                    result.LBA_TodayWrite = 0;
                    ConfigUtil.Save("LBATodayWrite", string.Format("{0}|{1}", strToday, lastNum));
                    LogUtil.Log(string.Format("当天起始数据：{0}|{1}", strToday, lastNum));
                }
                LogUtil.Log(string.Format("服务端读取固态硬盘信息成功：{0}G {1}G {2}PE", result.LBA_TodayWrite, result.LBA_Write, result.PE));
            }
            catch (Exception ex)
            {
                LogUtil.LogError(ex, "服务端读取固态硬盘信息失败");
            }

            return result;
        }
    }
}
